package ws.prova.reference;

import org.mandarax.util.logging.LogCategories;
import org.mandarax.kernel.ExtendedKnowledgeBase;
import org.mandarax.kernel.Predicate;
import ws.prova.calc.CalcPredicate;
import ws.prova.sql.SQLExtendedPredicate;

/**
 * Created by IntelliJ IDEA.
 * User: Alex
 * Date: 02-Jul-2006
 * Time: 11:10:01
 * To change this template use File | Settings | File Templates.
 */
public interface IProvaKnowledgeBase extends org.mandarax.kernel.KnowledgeBase, LogCategories, ExtendedKnowledgeBase {
    void addPolyPredicate( String s, Predicate pred );

    void dump();

    Object getPoly(Object key);

    CalcPredicate bcalc();

    CalcPredicate pcalc();

    SQLExtendedPredicate sqlExtendedPredicate();

    CalcPredicate calcPredicate(String type);

    Predicate poly(String pred, Predicate base);
}
